<template>
      <h1>Posts</h1>
      <my-input v-focus :model-value="searchQuery" @update:model-value="setSearchQuery" placeholder="Search..."/>
      <div class="app__btns">
        <my-button @click="showDialogue">Create post</my-button>
        <my-select :model-value="selectedSort" @update:model-value="setSelectedSort" :options="sortOptions"/>
      </div>
      <my-dialogue v-model:show="dialogueVisible">
        <PostForm @create="createPost" />
      </my-dialogue>
      <PostList v-if="!loading" :posts="sortedAndFilteredPosts" @remove="removePost"/>
      <div v-else>Loading...</div>
    <div class="observer" v-intersection="loadMorePosts"></div>
  </template>
    
  <script>
    import PostForm from '@/components/PostForm.vue'
    import PostList from '@/components/PostList.vue'
    import { mapActions, mapGetters, mapMutations, mapState } from 'vuex'
  
    export default {
      components: {PostForm, PostList},
      data(){
        return {
          dialogueVisible: false
        }
      },
      methods: {
        createPost(post) {
          this.setPosts([post, ...this.posts])
          this.dialogueVisible = false
        },
        removePost(post) {
          this.setPosts(this.posts.filter(p => p.id !== post.id))
        },
        showDialogue() {
          this.dialogueVisible = true
        },
        ...mapActions({
          fetchPosts: 'posts/fetchPosts',
          loadMorePosts: 'posts/loadMorePosts',
        }),
        ...mapMutations({
          setSearchQuery: 'posts/setSearchQuery',
          setSelectedSort: 'posts/setSelectedSort',
          setPosts: 'posts/setPosts',
        })
      },
      mounted() {
        this.fetchPosts()
      },
      computed: {
        ...mapState({
          posts: state => state.posts.posts,
          loading: state => state.posts.loading,
          searchQuery: state => state.posts.searchQuery,
          currentPage: state => state.posts.currentPage,
          pageSize: state => state.posts.pageSize,
          selectedSort: state => state.posts.selectedSort,
          totalPages: state => state.posts.totalPages,
          sortOptions: state => state.posts.sortOptions,
        }),
        ...mapGetters({
          sortedAndFilteredPosts: 'posts/sortedAndFilteredPosts'
        })
      }
    }
  </script>
  
  <style scoped>
  .app__btns {
    margin: 15px 0;
    display: flex;
    justify-content: space-between;
  }
  
  .page__wrapper {
    display: flex;
    margin-top: 15px;
  }
  
  .page {
    border: 1px solid black;
    padding: 10px;
  }
  
  .current-page {
    border: 2px solid teal;
  }
  </style>
  